#include "main.h"

char buf[buf_length];
char buf_res[buf_length];

int main(int argc, char *argv[]) {
	if(argc != 4) {
		fprintf(stderr, "usage: check_pop3 <server> <user> <password>\n");
		return 1;
	}
	int bytes_recv;

#if defined(_WIN32)
	WORD wVersionRequested = MAKEWORD(2, 2);;
	WSADATA wsaData;

	if(WSAStartup(wVersionRequested, &wsaData) != 0) {
		return -1;
	}

	if (LOBYTE(wsaData.wVersion) != 2 || HIBYTE(wsaData.wVersion) != 2 ) {
		printf("Server: The dll do not support the Winsock version %u.%u!\n", LOBYTE(wsaData.wVersion), HIBYTE(wsaData.wVersion));
		WSACleanup();
		return -1;
	}
#endif

	// create socket
	SOCKET sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET) {
		printSocketError("socket");
		return 1;
	}

	// connect
	struct sockaddr_in addr;
	addr.sin_family = AF_INET;
	addr.sin_port = htons(mail_port);
	addr.sin_addr.s_addr = inet_addr(argv[1]);
	if(connect(sock, (sockaddr*)&addr, sizeof(sockaddr_in)) == SOCKET_ERROR) {
		printSocketError("connect");
		return 1;
	}
	bytes_recv = recv(sock, buf, buf_length, 0);

	// auth
	auth(sock, argv[2], argv[3]);

	// read exists mail
	int letters_count = getLettersCount(sock);
	string last_date;
	printf("receiving exists mail\n");
	for(int i=0; i<letters_count; i++) {
		printf("\rgetting %d of %d...", i+1, letters_count);
		sprintf(buf, "RETR %d\n", i+1);
		sendCommand(sock, buf, "can't read letter", false);
		string tmp = getDateFromMessage(sock, "can't parse date");
		if(last_date == "" || tmp > last_date) last_date = tmp;
	}
	printf("\nok.\n");
	quit(sock);

	// check for new mail
	while(true) {
		sleepMilliseconds(10000);
		printf("\nchecking for new mail...\n");

		sock = socket(AF_INET, SOCK_STREAM, 0);
		if(connect(sock, (sockaddr*)&addr, sizeof(sockaddr_in)) == SOCKET_ERROR) {
			printSocketError("connect");
			return 1;
		}
		auth(sock, argv[2], argv[3]);

		int letters_count = getLettersCount(sock);
		int new_mail_count = 0;
		string new_last_date = last_date;
		for(int i=0; i<letters_count; i++) {
			printf("\rgetting %d of %d...", i+1, letters_count);
			sprintf(buf, "RETR %d\n", i+1);
			sendCommand(sock, buf, "can't read letter", false);
			string tmp = getDateFromMessage(sock, "can't parse date");
			if(last_date != "" && tmp > last_date) {
				new_mail_count++;
				if(tmp > new_last_date) new_last_date = tmp;
			}
		}
		last_date = new_last_date;
		if(new_mail_count)
			printf("\n%d new letters\n", new_mail_count);
		else
			printf("\nno new mail\n");
		quit(sock);
	}

	return 0;
}
