#include "mysock.h"

static char buf_res[buf_length];



#if defined(_WIN32)

void printSocketError(const char* msg) {
	fprintf(stderr, "%s: %d\n", msg, WSAGetLastError());
}

#else

void printSocketError(const char* msg) {
	perror(msg);
}

#endif



void sockSend(SOCKET sock, const char* msg, const char* errmsg) {
	int len = strlen(msg);
	int trans = 0;
	while(trans < len) {
		int t = send(sock, msg+trans, len-trans, 0);
		if(t == -1) {
			fputs(errmsg, stderr);
			printSocketError("send");
			exit(-1);
		}
		trans += t;
	}
}

void closeSocket(SOCKET sock) {
#if defined(_WIN32)
	closesocket(sock);
#else
	close(sock);
#endif

}

void sleepMilliseconds(long mseck) {
#if defined(_WIN32)
	Sleep(mseck);
#else
	usleep(mseck);
#endif
}